import { parseSet, serializeSet } from '../../schema/parser';
import { compose } from '../../util/compose';
export var Days;
(function (Days) {
    Days[Days["Sunday"] = 0] = "Sunday";
    Days[Days["Monday"] = 1] = "Monday";
    Days[Days["Tuesday"] = 2] = "Tuesday";
    Days[Days["Wednesday"] = 3] = "Wednesday";
    Days[Days["Thursday"] = 4] = "Thursday";
    Days[Days["Friday"] = 5] = "Friday";
    Days[Days["Saturday"] = 6] = "Saturday";
})(Days || (Days = {}));
;
function parseByDay(input) {
    return input.map(function (day) {
        switch (day) {
            case 'SU': return Days.Sunday;
            case 'MO': return Days.Monday;
            case 'TU': return Days.Tuesday;
            case 'WE': return Days.Wednesday;
            case 'TH': return Days.Thursday;
            case 'FR': return Days.Friday;
            case 'SA': return Days.Saturday;
            default:
                throw new Error("Encountered unexpected day value: '" + day + "'");
        }
    });
}
function serializeByDay(input) {
    var DaysMap = (_a = {},
        _a[Days.Sunday] = 'SU',
        _a[Days.Monday] = 'MO',
        _a[Days.Tuesday] = 'TU',
        _a[Days.Wednesday] = 'WE',
        _a[Days.Thursday] = 'TH',
        _a[Days.Friday] = 'FR',
        _a[Days.Saturday] = 'SA',
        _a
    );
    return input.map(function (day) { return DaysMap[day]; });
    var _a;
}
export var bydayDefinition = {
    parsedKey: 'byDay',
    parse: compose(parseByDay, parseSet),
    serializedKey: 'BYDAY',
    serialize: compose(serializeSet, serializeByDay)
};
