import { parseValue, serializeValue } from '../../schema/parser';
import { compose } from '../../util/compose';
export var Frequencies;
(function (Frequencies) {
    Frequencies[Frequencies["Yearly"] = 0] = "Yearly";
    Frequencies[Frequencies["Monthly"] = 1] = "Monthly";
    Frequencies[Frequencies["Weekly"] = 2] = "Weekly";
    Frequencies[Frequencies["Daily"] = 3] = "Daily";
    Frequencies[Frequencies["Hourly"] = 4] = "Hourly";
    Frequencies[Frequencies["Minutely"] = 5] = "Minutely";
    Frequencies[Frequencies["Secondly"] = 6] = "Secondly";
})(Frequencies || (Frequencies = {}));
;
function parseFrequencies(input) {
    switch (input) {
        case 'YEARLY': return Frequencies.Yearly;
        case 'MONTHLY': return Frequencies.Monthly;
        case 'WEEKLY': return Frequencies.Weekly;
        case 'DAILY': return Frequencies.Daily;
        case 'HOURLY': return Frequencies.Hourly;
        case 'MINUTELY': return Frequencies.Minutely;
        case 'SECONDLY': return Frequencies.Secondly;
        default:
            throw new Error("Encountered unexpected frequency value: '" + input + "'");
    }
}
function serializeFrequencies(input) {
    return Frequencies[input].toUpperCase();
}
export var freqDefinition = {
    parsedKey: 'frequency',
    parse: compose(parseFrequencies, parseValue),
    serializedKey: 'FREQ',
    serialize: compose(serializeValue, serializeFrequencies)
};
